/*
      [web:reg] Hodrick Prescott Filter - DLL
    
      © 2006, Kurt Annen
      email:  annen@web-reg.de
      web:    www.web-reg.de
      
      'Cardware'
      This DLL was written by Kurt Annen (www.web-reg.de/contact.html)
      If you like the program, please send me a postcard.

      
      data   - Array/Pointer (double) of raw data
      nobs   - Number of observations (data legth / Unsigned int)
      lambda - the smoothing parameter (double)
      output - Array/Pointer (double) where the filtered data will be stored
               Must be the same length as data.
      ret    - Boolean parameter. if ret is true, then the trend will be calculated
               otherwise the cyclical component will be calculated          
      
      
      Error codes
      
    ------- Errorcode ---------- Description --------------
            0         |          EXIT_SUCCESS
    ------------------------------------------------------- 
            1         |          nobs < 5
    -------------------------------------------------------  
            2         |          memory problem
    -------------------------------------------------------    
            3         |          singular Matrix
    -------------------------------------------------------  
      
*/      

#ifndef _HP_FILTER_H_
# define _HP_FILTER_H_

# include <cstdlib>

int hp_filter(double *data, size_t nobs, double lambda, double *output, bool ret);

#endif /* _HP_FILTER_H_ */
